#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <string.h>
#include "misc.h"

/***************************************************************************
  get_addr_data

  populates idat structure for comparison with dat
  returns  0 on success
  returns -1 on error
 ***************************************************************************/

char get_addr_data (idat, sin, type, sd)
    struct netinfo *idat;
    struct sockaddr_in *sin;
    char type;
    int sd;
{
    struct sockaddr_in localaddr;
    struct sockaddr_in *sasrc, *sadst;
    socklen_t addrlen = sizeof(localaddr);

    if (getsockname (sd, (struct sockaddr *)&localaddr, &addrlen))
        return -1;

    memset (idat, 0, sizeof(struct netinfo));

    if (type == INIT_CLI) {
        sasrc = &localaddr;
        sadst = sin;
    } else {
        sasrc = sin;
        sadst = &localaddr;
    }

    idat->src.host = sasrc->sin_addr.s_addr;
    idat->dst.host = sadst->sin_addr.s_addr;

    /* XXX: streamline this stuff */
    idat->src.port = sasrc->sin_port;
    idat->dst.port = sadst->sin_port;

    return 0;
}

