#include <sys/types.h>
#include <sys/mman.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include "misc.h"


/**************************************************************************
  increments the counter located within each flush file specified on the
  command line
 **************************************************************************/

int main (int argc, char **argv) {
    int fd;
    void *flushaddr;
    int r = 0;

    while (*(++argv)) {
        fd = open (*argv, O_RDWR);

        if (fd == -1) {
            perror (*argv);
            r = 1; continue;
        }

        flushaddr = mmap(0, 4, PROT_READ|PROT_WRITE, MAP_SHARED, fd, 0);

        if (flushaddr == (void *)-1) {
            perror (*argv);
            close(fd);
            r = 1; continue;
        }

        close (fd);

        printf ("flushaddr was: %x\n", (unsigned int)*(ub4_t *)flushaddr);
        (*(ub4_t *)flushaddr)++;
        printf ("flushaddr is now: %x\n", (unsigned int)*(ub4_t *)flushaddr);

        munmap (flushaddr, 4);
    }

    return r;
}
