#include "auto-stage.h"

#include <stdarg.h>
#include "misc.h"
#ifndef NAW_PRELOAD
#  include <sys/types.h>
#  include <sys/socket.h>
#  include "naw_api.h"
#endif

ub1_t naw_debug_level  = 0;
ub1_t naw_debug_noisy  = 0;
ub1_t force_block      = 0;
ub1_t fail_open        = 0;
char *module_dir       = 0;
char *module_flushfile = NAW_FLUSH_TRIGGER;

char *cdb_config[2] = {
    NAW_CONFIG_CLI,
    NAW_CONFIG_SRV
};

#ifndef NAW_PRELOAD
void naw_config (int type, ...) {
    va_list ap;

    va_start (ap, type);

    switch (type) {
        case NAW_SET_DEBUG_LEVEL:
            naw_debug_level = (ub1_t)va_arg(ap, int);
            break;
        case NAW_GET_DEBUG_LEVEL:
            *va_arg(ap, int *) = (int)naw_debug_level;
            break;
        case NAW_SET_DEBUG_NOISY:
            naw_debug_noisy = (ub1_t)va_arg(ap, int);
            break;
        case NAW_GET_DEBUG_NOISY:
            *va_arg(ap, int *) = (int)naw_debug_noisy;
            break;
        case NAW_SET_CONFIG_PATH_CONNECT:
            cdb_config[INIT_CLI] = va_arg(ap, char *);
            break;
        case NAW_GET_CONFIG_PATH_CONNECT:
            *va_arg(ap, char **) = cdb_config[INIT_CLI];
            break;
        case NAW_SET_CONFIG_PATH_ACCEPT:
            cdb_config[INIT_SRV] = va_arg(ap, char *);
            break;
        case NAW_GET_CONFIG_PATH_ACCEPT:
            *va_arg(ap, char **) = cdb_config[INIT_SRV];
            break;
        case NAW_SET_FLUSH_TRIGGER_PATH:
            module_flushfile = va_arg(ap, char *);
            break;
        case NAW_GET_FLUSH_TRIGGER_PATH:
            *va_arg(ap, char **) = module_flushfile;
            break;
    }

    va_end(ap);
}
#endif
