#include <stdlib.h>
#include "misc.h"

#if 0
	init_onexec()
	check if type is to be initialized on exec.
	type should be INIT_CLI to check for client (connect) status,
	or INIT_SRV for a server (accept).
	returns 1 if it is, 0 otherwise.

	METHODS:
		Currently only accepts environment variables.
		If the respective variable is set (regardless of what it is
		set to), we are to initialize on exec.

		The variables are NAW_INIT_CLI_ONEXEC for client,
		and NAW_INIT_SRV_ONEXEC for server.
#endif

char init_onexec (type)
	int type;
{
	char *exec_env;

	switch (type) {
		case INIT_CLI:
			exec_env = getenv ("NAW_INIT_CLI_ONEXEC");
			break;
		case INIT_SRV:
			exec_env = getenv ("NAW_INIT_SRV_ONEXEC");
			break;
		default:
			exec_env = 0;
	}

	if (exec_env) return 1;
	return 0;
}
