#include <sys/types.h>
#include <netinet/in.h>
#include "lxmisc.h"
#include "misc.h"
#include "data.h"

void log_data (idat, type, action)
	cfg_data *idat;
	char type, action;
{
	switch (action) {
		case ACTION_ALLOW: log_data_out (idat, type, "allow "); break;
                /*
		case ACTION_AUTH:  log_data_out (idat, type, "auth "); break;
                */
		case ACTION_DENY:  log_data_out (idat, type, "deny "); break;
	}
}

void log_data_out (idat, type, str)
	cfg_data *idat;
	char type, *str;
{
	if (!(idat->flags & FLAG_LOG)) return;

	if (type == INIT_SRV) log_ip (type, idat, str, 0,0, "from");
	else                  log_ip (type, idat, str, 0,0, "to");

}

#if 0
	adds ip address and port into s
	uses a pointer to the proper variable
	if port is 0, only the ip address is added.
	if addr is 0, only the port is added.
#endif

void gather_ip_port (s, addr, port)
	lx_s *s;
	unsigned long *addr;
	unsigned short *port;
{
	union {
		unsigned char address[4];
		unsigned long host;
	} un;

	if (addr) {
		un.host = *addr;

		if (lx_straddulong (s, (unsigned long) un.address[0], 10)
		 || lx_cadd (s, '.')
		 || lx_straddulong (s, (unsigned long) un.address[1], 10)
		 || lx_cadd (s, '.')
		 || lx_straddulong (s, (unsigned long) un.address[2], 10)
		 || lx_cadd (s, '.')
		 || lx_straddulong (s, (unsigned long) un.address[3], 10))
			die_nomem();
		if (port) if (lx_stradd (s, IP_PORT_SEP)) die_nomem();
	}
	if (port) {
		if (lx_straddulong(s, (unsigned long) ntohs(*port), 10))
			die_nomem();
	}
}
