#ifndef NAW_MODULEDATA_H
#define NAW_MODULEDATA_H

/**********************************************************************
  naw_mod_mainlink: initial module chain, stored in list
  all further module chains are of type naw_mod_link and are populated
  from this module list.

  note: the main purpose of inject_f() is to set up the new
  naw_mod_link element for type.
 **********************************************************************/
#if 0
typedef struct naw_mod_mainlink {
	char *name;   /* filename of module (on filesystem) */
	char *label;  /* may be given by init function */
	int (*inject_f) (struct naw_mod_link *fdat, int type);
	struct naw_mod_mainlink *next;
} naw_mod_mainlink;


typedef struct naw_mod_link {
	char *name;  /* for reporting purposes on fail */
	char *something;
	int (*act_f) (naw_mod_data *dat);
	struct naw_mod_link *next;
} naw_mod_link;
#endif

typedef struct modentry {
    /*
    unsigned int
        loaded      :1,
        initialized :1,
        refcount    :16,
        pad         :14;
    */
    void *dl_handle;
    unsigned char  initialized;
    unsigned short refcount;

    lx_s name;

    int (*f_init) (void);
    int (*f_fini) (void);
    int (*f_deny) (naw_mod_data *dat);
    int (*f_allow)(naw_mod_data *dat);
} modentry;

typedef struct naw_mod_data {
	lx_sa env;
} naw_mod_data;

typedef struct modlinkstub {
    struct modlinkstub  *stub_next;
    struct modentry     *module;
    struct naw_mod_data  mod_data;
} modlinkstub;

#if 0
typedef struct naw_blob_link {
	char data[3*sizeof(void *)];
	void *next;
} naw_blob_link;
#endif

#endif /* NAW_MODULEDATA_H */
